<template>
    <div class="execution">
        <basic-container>
            <avue-crud ref="crud"
                       :page.sync="page"
                       :data="tableData"
                       :permission="permissionList"
                       :table-loading="tableLoading"
                       :option="tableOption"
                       @on-load="getList"
                       @search-change="searchChange"
                       @refresh-change="refreshChange"
                       @size-change="sizeChange"
                       @current-change="currentChange"
                       @row-update="handleUpdate"
                       @row-save="handleSave"
                       @row-del="handleDel">
                <template slot="menuLeft">
                    <el-button
                        v-if="permissions.admin_mallgoodssku_export"
                        class="filter-item"
                        plain
                        type="primary"
                        size="small"
                        icon="el-icon-download"
                        @click="exportExcel">导出
                    </el-button>
                    <el-button
                        class="filter-item"
                        v-if="permissions.admin_mallgoodssku_del"
                        plain
                        type="primary"
                        size="small"
                        icon="el-icon-remove"
                        @click="handleDelBatch">批量删除
                    </el-button>
                </template>
            </avue-crud>
        </basic-container>
    </div>
</template>

<script>
    import {fetchList, getObj, addObj, putObj, delObj} from '@/api/mall/mallgoodssku'
    import {tableOption} from '@/const/crud/mall/mallgoodssku'
    import {mapGetters} from 'vuex'

    export default {
        name: 'mallgoodssku',
        data() {
            return {
                searchForm: {},
                tableData: [],
                page: {
                    total: 0, // 总页数
                    currentPage: 1, // 当前页数
                    pageSize: 20 // 每页显示多少条
                },
                tableLoading: false,
                tableOption: tableOption
            }
        },
        computed: {
            ...mapGetters(['permissions']),
            permissionList() {
                return {
                    addBtn: this.vaildData(this.permissions.admin_mallgoodssku_add, false),
                    delBtn: this.vaildData(this.permissions.admin_mallgoodssku_del, false),
                    editBtn: this.vaildData(this.permissions.admin_mallgoodssku_edit, false)
                };
            }
        },
        methods: {
            // 列表查询
            getList(page, params) {
                this.tableLoading = true
                fetchList(Object.assign({
                    current: page.currentPage,
                    size: page.pageSize
                }, params, this.searchForm )).then(response => {
                    this.tableData = response.data.data.records
                    this.page.total = response.data.data.total
                    this.tableLoading = false
                }).catch(() => {
                    this.tableLoading=false
                })
            },
            // 删除
            handleDel: function (row, index) {
                this.$confirm('是否确认删除？', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(function () {
                    return delObj(row.id)
                }).then(data => {
                    this.$message.success('删除成功')
                    this.getList(this.page)
                })
            },
            // 批量删除
            handleDelBatch() {
                if (this.$refs.crud.tableSelect.length === 0) {
                    this.$message.error('请选择项进行删除')
                    return false
                }
                let ids = []
                for (const row of this.$refs.crud.tableSelect) {
                    ids.push(row.id)
                }

                this.$confirm('是否确认删除？', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(function () {
                    return delObj(ids)
                }).then(data => {
                    this.$notify.success('删除成功')
                    this.$refs.crud.toggleSelection();
                    this.refreshChange();
                })
            },
            // 更新
            handleUpdate: function (row, index, done,loading) {
                putObj(row).then(data => {
                    this.$message.success('修改成功')
                    done()
                    this.getList(this.page)
                }).catch(() => {
                    loading();
                });
            },
            // 保存
            handleSave: function (row, done,loading) {
                addObj(row).then(data => {
                    this.$message.success('添加成功')
                    done()
                    this.getList(this.page)
                }).catch(() => {
                    loading();
                });
            },
            // 每页条数改变事件
            sizeChange(pageSize){
                this.page.pageSize = pageSize
            },
            // 当前页发生改变事件
            currentChange(current){
                this.page.currentPage = current
            },
            // 查询事件
            searchChange(form, done) {
                this.searchForm = form
                this.page.currentPage = 1
                this.getList(this.page, form)
                done()
            },
            // 刷新事件
            refreshChange() {
                this.getList(this.page)
            },
            //  导出excel
            exportExcel() {
                this.downBlobFile('/admin/mallgoodssku/export',this.searchForm, 'mallgoodssku.xlsx')
            }
        }
    }
</script>
